﻿local WILD_CHARGE_SPELL_ID = {
	[1] = 49376,
	[3] = 102417,
	[4] = 102416,
	[5] = 16979,
	[31] = 102383
}

local MSS_TalentTooltip = CreateFrame("GameTooltip", "MSS_SymbiosisTooltip", nil, "GameTooltipTemplate")
MSS_SymbiosisTooltip:SetScale(0.8)
--
-- Provoked when talents are updated
--
function SetTalentActions(self, event)		
		
	if event  ~= "UPDATE_SHAPESHIFT_FORM" then		
		local i
		for i = 1,6 do
			local button = _G["MSS_TalentActionBar_Button"..i]
			local isFree, index = GetTalentRowSelectionInfo(i)
			if not isFree then
				local name,icon = GetTalentInfo(index)			
				local mlink, _ = GetSpellLink(name)	
				button.icon:SetTexture(icon)
				if mlink ~= nil then			
					--print(mlink)
					local _, sid = strsplit(":", strmatch(mlink, "spell:%d+"))			
					--print("In "..name.."="..sid)				
					if not IsPassiveSpell(name) or sid == "106707"--[[faeris sworm]] then
								
							if sid == "106707" then	--faeris sworm				
								button:SetAttribute("spell", 770);
								button:SetScript("OnUpdate", function(self)
										local start, duration, enable = GetSpellCooldown(102355)
										self.cooldown:SetCooldown(start, duration)
									end
								)
								button:SetScript("OnEnter", function(self)
									MSS_SymbiosisTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
									MSS_SymbiosisTooltip:ClearLines()
									MSS_SymbiosisTooltip:SetSpellByID(102355)					
									end
								)
							else 
								button:SetAttribute("spell", name);
								button:SetScript("OnUpdate", function(self)
										local start, duration, enable = GetSpellCooldown(name)
										self.cooldown:SetCooldown(start, duration)
									end
								)
								button:SetScript("OnEnter", function(self)
									MSS_SymbiosisTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
									MSS_SymbiosisTooltip:ClearLines()
									MSS_SymbiosisTooltip:SetSpellByID(sid)					
									end
								)
								
								--[[
								elseif sid == "102558" or sid=="102543" or sid == "102560" or sid=="33891"  then  --incarnation
									button:SetAttribute("spell", name);--PickupSpell(106731)
								elseif sid == "33831" or sid=="102703" or sid == "102706" or sid=="102693"  then --trent
									button:SetAttribute("spell", name);--PickupSpell(106737)
								else							
									button:SetAttribute("spell", tonumber(sid));
									]]
							end
							
							
							
							
					else -- Passive talent
						button:SetAttribute("spell", "");	
						button:SetScript("OnEnter", function(self)
									MSS_SymbiosisTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
									MSS_SymbiosisTooltip:ClearLines()
									MSS_SymbiosisTooltip:SetSpellByID(sid)					
									end
						)						
					end
					button:SetScript("OnLeave", function(self)						
										MSS_SymbiosisTooltip:Hide()
									end
								)
				end
			else -- no talent at tier i
				button:SetAttribute("spell", "");
				button.icon:SetTexture("Interface\\ICONS\\INV_Misc_QuestionMark")
				button:SetScript("OnUpdate", nil)
				button:SetScript("OnEnter", nil)
			end
		end
	end	
	
	local free, ind = GetTalentRowSelectionInfo(1)
	if not free and ind == 3 then -- wild charge selected
		local formId = GetShapeshiftFormID()
		local spellId = WILD_CHARGE_SPELL_ID[formId];			
		if not spellId then				
			local name, icon = GetTalentInfo(3)
			MSS_TalentActionBar_Button1:SetAttribute("spell", name);
			MSS_TalentActionBar_Button1.icon:SetTexture(icon)
		else 						
			local name, _, icon = GetSpellInfo(spellId)
			MSS_TalentActionBar_Button1:SetAttribute("spell", name);
			MSS_TalentActionBar_Button1.icon:SetTexture(icon)
		end
	end
end

function MSS_TalentActionBar_OnLoad(self)
	for i = 1,6 do
		local btn = CreateFrame("Button", "MSS_TalentActionBar_Button"..i, self, "MSS_TalentButton_T");
		btn:SetPoint("LEFT", self, "LEFT", 12 + 37*(i-1), 0)
		btn:SetAttribute("type", "spell");
	end


end

-- binding
BINDING_HEADER_MYDOSTUFF = L["addon_name"];
for i=1,6 do
	_G["BINDING_NAME_CLICK MSS_TalentActionBar_Button"..i..":LeftButton"] = L["talent"]..i
end

--[[
function TimeMaskOnEvent(self, event, ...)			
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	if sourceName == UnitName("player") then
		
		if eventType == "SPELL_CAST_SUCCESS" or eventType == "AURA_APPLIED" then
			local spellId, spellName, spellSchool = select(12, ...)
			local auraType = select(15, ...)			
			--print(eventType.."-"..spellId.."-"..spellName)
			
			if self:GetName() == "MSS_TalentBar_TimeMask3" then
				if spellId == 102355 then --sworm					
					self.count = 15
				elseif spellId == 102359 then --mass tangle
					self.count = 20
				elseif spellId == 132469 then --typhoon
					self.count = 6
				end
			
			elseif self:GetName() == "MSS_TalentBar_TimeMask4" then
				if spellId == 102560 or spellId == 102543 or spellId == 102558 or spellId == 33891 then --incarnation 4 id moonkin cat bear  tree			
					self.count = 30
				elseif spellId == 33831 or spellId == 102703  or spellId == 102706 or spellId == 102693 then --trent 4 id
					self.count = 15
				end			
				
			elseif self:GetName() == "MSS_TalentBar_TimeMask5" then
				if spellId == 99 then --roar					
					self.count = 3
				elseif spellId == 102793 then --vortex
					self.count = 10
				elseif spellId == 5211 then --bash
					self.count = 5
				end				
			end
			
			if self.count ~= 0 then
				if self.text == nil then
					self.text = self:CreateFontString(nil, "OVERLAY", "PVPInfoTextFont")
				end
				self.text:SetAllPoints();
				self.total = 0
				self:SetFrameLevel(100)
				self.text:SetText(self.count)
				self.text:SetTextColor(0,1,0)
				self:Show()
			end
		end
	end
end

function TimeMaskOnUpdate(self, elapsed) 	
	if self.total ~= nil then
		self.total = self.total + elapsed
	
		if self.total >= 1. then
			if self.count ~= nil and self.count > 0 then
				self.count = self.count -1
				self.text:SetText(self.count)
			end
			if self.count == 0 then
				self:Hide()
			end
			self.total = 0
		end
	end
end


function Option_Command_Talent_TimerPos(pos)
	MSS_SavedOptions["talent_timer_pos"] = pos
	if pos == "top" then
		MSS_OptionPanel_CheckButton_TalentTimerPos:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_TalentTimerPos:SetChecked(false)
	end
	
	if pos == "top" then
		MSS_TalentBar_TimeMask3:SetPoint("CENTER", MSS_TalentButton3, "CENTER", 0, 27)
		MSS_TalentBar_TimeMask4:SetPoint("CENTER", MSS_TalentButton4, "CENTER", 0, 27)
		MSS_TalentBar_TimeMask5:SetPoint("CENTER", MSS_TalentButton5, "CENTER", 0, 27)	
	else 
		MSS_TalentBar_TimeMask3:SetPoint("CENTER", MSS_TalentButton3, "CENTER", 0, -27)
		MSS_TalentBar_TimeMask4:SetPoint("CENTER", MSS_TalentButton4, "CENTER", 0, -27)
		MSS_TalentBar_TimeMask5:SetPoint("CENTER", MSS_TalentButton5, "CENTER", 0, -27)	
	end
end
]]
ShowMsg("TalentActionBar Loaded...")	


